/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.MapLoginUserToProfile;
import com.portofolio.entity.vo.MapLoginUserToProfileId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface MapLoginUserToProfileDao extends CrudRepository<MapLoginUserToProfile, MapLoginUserToProfileId> {

	MapLoginUserToProfile findOneByIdKdUserAndIdKdProfileAndIdKdModulAplikasiAndIdKdRuangan(Long kdUser,
			Integer kdProfile, String kdModulAplikasi, String kdRuangan);

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page);

	@Query(QListAll + " and model.id.kdUser = :kdUser ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("kdUser") Long kdUser,
			Pageable page);

	@Query(QListAllMA)
	List<String> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kdUser") Long kdUser);

	@Query(QListAllModul + " and model.id.kdUser =:kdUser")
	List<Map<String, Object>> getModulByKodeUser(@Param("kdProfile") Integer kdProfile,
			@Param("kdUser") Long kdUser);
	
	List<MapLoginUserToProfile> findAllByIdKdProfileAndIdKdUser(@Param("kdProfile") Integer kdProfile,
			@Param("kdUser") Long kdUser);

	@Query(QListAllRuangan + " and model.id.kdUser =:kdUser")
	List<Map<String, Object>> getRuanganByKodeUser(@Param("kdProfile") Integer kdProfile, @Param("kdUser") Long kdUser);

	@Modifying
	@Query("update MapLoginUserToProfile m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdUser =:kdUser")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile, @Param("kdUser") Long kdUser);

	String QListAll = "select new map(loginUser.namaUserEmail as namaUserEmail,loginUser.kdUser as kdUser,model.statusEnabled as statusEnabled,ruangan.namaRuangan as namaRuangan,ruangan.id.kdRuangan as kdRuangan,modulAplikasi.kdModulAplikasi as kdModulAplikasi,modulAplikasi.namaModulAplikasi as namaModulAplikasi "
			+ ", model.noRec as noRec " + ",   model.version as version )"
			+ " from MapLoginUserToProfile model left join model.id id left join model.ruangan ruangan left join model.loginUser loginUser left join model.modulAplikasi modulAplikasi where id.kdProfile =:kdProfile ";

	Long countIdKdUserByIdKdUserAndIdKdProfile(Long kdUser, Integer kdProfile);

	String QListAllMA = "select distinct(model.id.kdModulAplikasi) from MapLoginUserToProfile model left join model.id id where id.kdProfile =:kdProfile and model.statusEnabled = true  and model.id.kdUser = :kdUser";

	String QListAllRuangan = "select new map( model.id.kdRuangan as kdRuangan,ruangan.namaRuangan as namaRuangan)"
			+ " from MapLoginUserToProfile model left join model.id id " + " left join model.ruangan ruangan "
			+ "where id.kdProfile =:kdProfile ";

	String QListAllModul = "select new map( model.id.kdModulAplikasi as kode, modulAplikasi.namaModulAplikasi as namaModulAplikasi)"
			+ " from MapLoginUserToProfile model left join model.id id "
			+ " left join model.modulAplikasi modulAplikasi "
			+ "where id.kdProfile =:kdProfile ";

}
